#! /usr/bin/env python
import mb_cgi

class SessionSignOff(mb_cgi.JSONCGI):
    """
    This class signs off an authenticated session, by creating
    a new anonymous session
    
    @author: Herve Menager
    @organization: Institut Pasteur
    @contact:mobyle@pasteur.fr
    """

    def process(self):
      try:
        if (self.cfg.anonymousSession()!='no'):
          self.session = self.sessionFactory.getAnonymousSession()
          self.sessionKey = self.session.getKey()
        else: 
          self.session = None
          self.sessionKey = None
        self.jsonMap['accountOk'] = str(True)
      except Exception, e:
        self.jsonMap['accountOk'] = str(False)        
        self.jsonMap['msg'] = str(e)

if __name__ == "__main__":
    sso = mb_cgi.SessionCGI(SessionSignOff())
    sso.process()
    sso.read_session()
    sso.render()

