from distutils.core import setup, Extension

module1 = Extension('siginterrupt',
                    sources = ['siginterrupt.c']
                    )
setup (
    name = 'siginterrupt',
    version = '1.0',
    description = 'The  siginterrupt()  function  changes  the  restart behaviour when a system call is\ninterrupted by the signal sig.  If the flag argument is false (0), then system calls\nwill  be  restarted if interrupted by the specified signal sig.  This is the default\nbehaviour in Linux.  However, when a new signal handler is specified with  the  sig-\nnal(2) function, the system call is interrupted by default.\n\nIf  the  flags  argument is true (1) and no data has been transferred, then a system\ncall interrupted by the signal sig will return -1 and the global variable errno will\nbe set to EINTR.\n\nIf  the  flags  argument  is true (1) and data transfer has started, then the system\ncall will be interrupted and will return the actual amount of data transferred.\n',
    
    ext_modules = [module1]
    )
